Sets
     supplyplace   'canning plants'
     demandplace   'markets';

Parameter trancost(supplyplace,demandplace)  'distance in thousands of miles'
          supplymax(supplyplace)    'capacity of plant supplyplace in cases'
          demandmin(demandplace)    'demand at market demandplace in cases';
Scalar f  'freight in dollars per case per thousand miles';

$onEmbeddedCode Python:
  alldemand=[]
  demand=[]
  demandq=[]
  supplyq=[]
  allsupply=[]
  supply=[]
  cost=[]
  from openpyxl import load_workbook
  wb = load_workbook(filename = 'myspread.xlsx')
  problem = wb['input']
  for n in range(2, problem.max_column):
      demandelement = problem.cell(row=1,column=n).value
      demandqelement = problem.cell(row=problem.max_row,column=n).value
      demand.append(demandelement)
      demandq.append((demandelement,demandqelement))
  for n in range(1, problem.max_column+1):
      demandelement = problem.cell(row=1,column=n).value
      alldemand.append(demandelement)
  for n in range(2, problem.max_row):
      supplyelement = problem.cell(row=n,column=1).value
      supplyqelement = problem.cell(row=n,column=problem.max_column).value
      supply.append(supplyelement)
      supplyq.append((supplyelement,supplyqelement))
  for n in range(2, problem.max_row+1):
      supplyelement = problem.cell(row=n,column=1).value
      allsupply.append(supplyelement)
  for n in range(2,problem.max_column):
      for r in range(2, problem.max_row):
          cost.append( (problem.cell(row=r,column=1).value, problem.cell(row=1,column=n).value, problem.cell(row=r,column=n).value) )
  print (cost)
  for supply, demand in [('supplyplace',supply), ('demandplace',demand), ('supplymax', supplyq), ('demandmin', demandq), ('trancost',cost)]:
    gams.set(supply, demand)
  wb.close()
$offEmbeddedCode supplyplace demandplace supplymax demandmin trancost



Variables
     x(supplyplace,demandplace)  'shipment quantities in cases'
     z       'total transportation costs in thousands of dollars' ;

Positive Variable x ;

Equations
     cost        'define objective function'
     supplyeq(supplyplace)   'observe supplyplace limit at plant supplyplace'
     demandeq(demandplace)   'satisfy demandplace at market demandplace' ;

cost ..        z  =e=  sum((supplyplace,demandplace), trancost(supplyplace,demandplace)*x(supplyplace,demandplace)) ;

supplyeq(supplyplace) ..   sum(demandplace, x(supplyplace,demandplace))  =l=  supplymax(supplyplace) ;

demandeq(demandplace) ..   sum(supplyplace, x(supplyplace,demandplace))  =g=  demandmin(demandplace) ;

Model transport /all/ ;

Solve transport using lp minimizing z ;

embeddedCode Python:
  from openpyxl import load_workbook
  wb = load_workbook(filename = 'myspread.xlsx')
  if 'output' in wb.get_sheet_names():
    output=wb.get_sheet_by_name('output')
    wb.remove_sheet(output)
  output = wb.create_sheet('output')
  for rec in gams.get('x', keyFormat=KeyFormat.FLAT, valueFormat=ValueFormat.FLAT):
    output.append(rec[0:3])
  wb.save('myspread.xlsx')
endEmbeddedCode

Display x.l, x.m ;
