$offlog
Set
   commod commodities / corn,wheat,hay,cotton, sorghum /
   sd    supply demand  / supply, demand /
   curveparam           /intercept,slope/;

table
   curvedata(commod,sd,curveparam) 'supply demand data'
                supply.intercept  supply.slope  demand.intercept  demand.slope

    corn              1                 .01           12              -0.01
    wheat              .1               .05           16              -0.01
    hay               1.2               .1            80              -0.33
    cotton            0.5               .005          33              -0.01
    sorghum           0.7               .01           11              -0.01

parameter targetprice(commod)
/   corn           9.500
    wheat         14.350
    hay           32.526
    cotton        18.333
    sorghum       7.950      /;

parameter initialguess(commod);
       initialguess(commod)=0;


Positive Variable
   demand(commod) 'demand quantities in cases'
   supply(commod) 'supply quantities in cases'

Variable
   z              'welfare';

Equation
   CSPS      'define objective function'
   balance(commod) 'balance a commodoitey'
   simultaeoussupplylim 'satisfy demand at market j';

csps..        z  =e=  sum(commod, curvedata(commod,"demand","intercept")*demand(commod)+curvedata(commod,"demand","slope")*sqr(demand(commod)))
                     -sum(commod, curvedata(commod,"supply","intercept")*supply(commod)+curvedata(commod,"supply","slope")*sqr(supply(commod)))
                     +sum(commod,initialguess(commod)*demand(commod));  ;


balance(commod)..   demand(commod) =l= supply(commod);

simultaeoussupplylim..   sum(commod, supply(commod)) =l= 2000;

Model mod / all /;

set ht / modelStat, solveStat, resUsd /;
parameter  mInfo(ht) save solution stuff;

set step /s1*s500/
parameter data(commod,step,*);
scalar count,count2,count3;
count=1;
option limrow=0;
option limcol=0;
option solprint=silent;
singleton set step2(step);

option solvelink=2;
$set useSolverLog 1
$set solverlog
$if set useSolverLog $set solverlog output=sys.stdout

embeddedCode Python:
from gmomcc import *
def solveMI(mi, mInfo, symIn=[], symOut=[]):
  for sym in symIn:
    gams.db[sym].copy_symbol(mi.sync_db[sym])
  mi.solve(%solverlog%)
  for sym in symOut:
    mi.sync_db[sym].copy_symbol(gams.db[sym])
  gams.set(mInfo,[('modelStat',mi.model_status), ('solveStat',mi.solver_status), ('resUsd', gmoGetHeadnTail(mi._gmo,gmoHresused))])
pauseEmbeddedCode

$libinclude pyEmbMI modinstance 'mod using nlp max z' -all_model_types=conoptd initialguess.Zero

count2=10;
alias(step,steps);
step2(steps)$(ord(steps)=count2)=yes;
count3=0;
loop(step$(count>0),
        count3=count3+1;
        continueEmbeddedCode:
            solveMI(modinstance,'mInfo',['initialguess'],['balance'])
        pauseEmbeddedCode balance mInfo
*        solve mod using nlp maximizing z;
        step2(steps)$(ord(steps)=count2)=yes;
        data(commod,step2,'targetprice')=targetprice(commod);
        data(commod,step2,'currentprice')=balance.m(commod);
        data(commod,step2,'defic_guess') =initialguess(commod);
        data(commod,step2,'difference'  )=targetprice(commod)-data(commod,step2,'currentprice');
        data(commod,step2,'newguess')    =max(0,initialguess(commod)+0.2*data(commod,step2,'difference'  ));
        initialguess(commod)=data(commod,step2,'newguess');
        count:=sum(commod$(abs(data(commod,step2,'difference'  ))>0.00001),1);
        if ((count3>count2), count2=count2+10);
        step2(steps)$(ord(steps)=count2)=yes;
);
display data;
